## caml-mode 4.06

=== Makefile ===
#**************************************************************************
#*                                                                        *
#*                                 OCaml                                  *
#*                                                                        *
#*            Xavier Leroy, projet Cristal, INRIA Rocquencourt            *
#*                                                                        *
#*   Copyright 1997 Institut National de Recherche en Informatique et     *
#*     en Automatique.                                                    *
#*                                                                        *
#*   All rights reserved.  This file is distributed under the terms of    *
#*   the GNU General Public License.                                      *
#*                                                                        *
#**************************************************************************

VERSION = $(shell grep "^version" caml-mode.opam \
	| sed -e 's/version: *"\([^"]*\)"/\1/')
DESCRIPTION = $(shell grep ';;; caml.el ---' caml.el \
	| sed 's/[^-]*--- *\(.*\)/\1/')
DIST_DIR = caml-mode-$(VERSION)
OPAM_DIR = caml-mode.$(VERSION)
TARBALL = caml-mode-$(VERSION).tgz

# Files to install
FILES=	caml-font.el caml-hilit.el caml.el camldebug.el \
	inf-caml.el caml-compat.el caml-help.el caml-types.el \
	caml-xemacs.el caml-emacs.el caml-mode-site-file.el

DIST_FILES = $(FILES) Makefile README* COPYING* CHANGES.md ocamltags.in

# Where to install. If empty, automatically determined.
#EMACSDIR=

# Name of Emacs executable
EMACS=emacs

# Where to install ocamltags script
SCRIPTDIR = $(BINDIR)

# Command for byte-compiling the files
COMPILECMD=(progn \
	      (setq load-path (cons "." load-path)) \
	      (byte-compile-file "caml-xemacs.el") \
	      (byte-compile-file "caml-emacs.el") \
	      (byte-compile-file "caml.el") \
	      (byte-compile-file "inf-caml.el") \
	      (byte-compile-file "caml-help.el") \
	      (byte-compile-file "caml-types.el") \
	      (byte-compile-file "caml-font.el") \
	      (byte-compile-file "camldebug.el"))

caml-mode-site-file.el: $(SOURCES)
	(echo ";;; $@ --- Automatically extracted autoloads.";\
	 echo ";;; Code:";\
	 echo "(add-to-list 'load-path";\
	 echo "             (or (file-name-directory load-file-name) (car load-path)))";\
	 echo "") >$@
	$(EMACS) --batch --eval '(setq generated-autoload-file "'`pwd`'/$@")' -f batch-update-autoloads "."

install:
	@if test "$(EMACSDIR)" = ""; then \
	  $(EMACS) --batch --eval 't; see PR#5403'; \
	  set xxx `($(EMACS) --batch --eval "(mapcar 'print load-path)") \
				2>/dev/null | \
	           sed -n -e 's/^"\(.*\/site-lisp\).*/\1/gp' | \
		   sort -u`; \
	  if test "$$2" = "" -o "$$3" != ""; then \
	    echo "Cannot determine Emacs site-lisp directory:"; \
            shift; while test "$$1" != ""; do echo "\t$$1"; shift; done; \
	  else \
	  $(MAKE) EMACSDIR="$$2" simple-install; \
	  fi; \
	else \
	  $(MAKE) simple-install; \
	fi

# install the .el files, but do not compile them.
install-el:
	$(MAKE) NOCOMPILE=true install

simple-install:
	@echo "Installing in $(EMACSDIR)..."
	if test -d $(EMACSDIR); then : ; else mkdir -p $(EMACSDIR); fi
	$(INSTALL_DATA) $(FILES) $(EMACSDIR)
	if [ -z "$(NOCOMPILE)" ]; then \
	  cd $(EMACSDIR); $(EMACS) --batch --eval '$(COMPILECMD)'; \
	fi

ocamltags:	ocamltags.in
	sed -e 's:@EMACS@:$(EMACS):' ocamltags.in >ocamltags
	chmod a+x ocamltags

install-ocamltags: ocamltags
	$(INSTALL_DATA) ocamltags $(SCRIPTDIR)/ocamltags

# OPAM
.PHONY: opam
opam: $(TARBALL)
	mkdir -p $(OPAM_DIR)
	cp -a caml-mode.opam $(OPAM_DIR)/opam
	echo "url {" >> $(OPAM_DIR)/opam
	echo "  src: \"`pwd`/https://github.com/ocaml/caml-mode/releases/download/$(VERSION)/$(TARBALL)\"" >> $(OPAM_DIR)/opam
	echo "  checksum: \"md5=`md5sum $(TARBALL) | cut -d ' ' -f 1`\"" \
	  >> $(OPAM_DIR)/opam
	echo "}" >> $(OPAM_DIR)/opam

$(TARBALL): $(DIST_FILES)
	mkdir -p $(DIST_DIR)
	for f in $(DIST_FILES); do cp $$f $(DIST_DIR); done
	echo "(define-package \"caml\" \"$(VERSION)\" \"$(DESCRIPTION)\" \
		)" > $(DIST_DIR)/caml-pkg.el
	tar acvf $@ $(DIST_DIR)
	$(RM) -rf $(DIST_DIR)

# This is for testing purposes
compile-only:
	$(EMACS) --batch --eval '$(COMPILECMD)'

clean:
	rm -f ocamltags *~ \#*# *.elc
	$(RM) -r $(TARBALL) $(OPAM_DIR)

=== debian/changelog ===
caml-mode (4.06-2) unstable; urgency=medium
 
  * Upload to unstable for the transition from ocaml 4.05 to 4.08, which
    no longer distributes ocaml-mode (closes: #920229)
  * Standards-Version 4.4.1 (no change)

 -- Ralf Treinen <treinen@debian.org>  Thu, 07 Nov 2019 08:10:28 +0100

caml-mode (4.06-1) experimental; urgency=medium

  * Initial package (closes: #933241).
    This used to be part of the ocaml release until ocaml 4.05.

 -- Ralf Treinen <treinen@debian.org>  Fri, 16 Aug 2019 15:07:50 +0200

=== debian/control ===
Source: caml-mode
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Ralf Treinen <treinen@debian.org>,
Build-Depends: debhelper-compat (= 12), dh-elpa
Standards-Version: 4.4.1
Homepage: https://github.com/ocaml/caml-mode
Vcs-Git: https://salsa.debian.org/ocaml-team/caml-mode.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/caml-mode

Package: elpa-caml
Architecture: all
Depends: ${misc:Depends}, ${elpa:Depends} 
Replaces: ocaml-mode (<< 4.06)
Breaks: ocaml-mode (<< 4.06)
Description: emacs mode for editing OCaml programs
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package provides support for editing both Objective Caml and
 Caml Light programs with Emacs and XEmacs.
 .
 Caml-mode supports:
  - indentation
  - compilation and error retrieving
  - interaction with the toplevel
  - font-lock
  - imenu

Package: ocaml-mode
Architecture: all
Depends: elpa-caml, ${misc:Depends}
Section: oldlibs
Description: transitional package to elpa-caml
 This is a transitional package from the old ocaml-mode to the
 new elpa-caml package. It can be safely removed.

## caml-mode 4.9

=== Makefile ===
#**************************************************************************
#*                                                                        *
#*                                 OCaml                                  *
#*                                                                        *
#*            Xavier Leroy, projet Cristal, INRIA Rocquencourt            *
#*                                                                        *
#*   Copyright 1997 Institut National de Recherche en Informatique et     *
#*     en Automatique.                                                    *
#*                                                                        *
#*   All rights reserved.  This file is distributed under the terms of    *
#*   the GNU General Public License.                                      *
#*                                                                        *
#**************************************************************************

VERSION = $(shell grep "^;; *Version" caml.el \
	| sed -e 's/;; *Version: *\([^ \t]*\)/\1/')
SYNOPSIS = $(shell grep ';;; caml.el ---' caml.el \
	| sed 's/[^-]*--- *\([^-]\+\) \+.*/\1/')
DIST_NAME = caml-mode-$(VERSION)
TARBALL = caml-mode-$(VERSION).tgz
OPAM_FILE = packages/caml-mode/caml-mode.$(VERSION)/opam

# Files to install
FILES=	caml-font.el caml.el camldebug.el      \
	inf-caml.el caml-help.el caml-types.el

INSTALL_DIR ?= $(shell opam var share)/emacs/site-lisp
INSTALL_BIN ?= $(shell opam var bin)

DIST_FILES = $(FILES) Makefile README* COPYING* CHANGES.md ocamltags.in

# Name of Emacs executable
EMACSFORMACOSX = /Applications/Emacs.app/Contents/MacOS/Emacs
EMACSMACPORTS = /Applications/MacPorts/Emacs.app/Contents/MacOS/Emacs
AQUAMACS = $(shell test -d /Applications \
	&& find /Applications -type f | grep 'Aquamacs$$')
ifeq ($(wildcard $(EMACSFORMACOSX)),$(EMACSFORMACOSX))
EMACS ?= $(EMACSFORMACOSX)
else
ifeq ($(wildcard $(EMACSMACPORTS)),$(EMACSMACPORTS))
EMACS ?= $(EMACSMACPORTS)
else
ifneq ($(strip $(AQUAMACS)),)
ifeq ($(wildcard $(AQUAMACS)),$(AQUAMACS))
EMACS ?= $(AQUAMACS)
endif
endif
endif
endif
EMACS ?= emacs

INSTALL_MKDIR = mkdir -p
INSTALL_DATA = cp
INSTALL_RM_R = $(RM) -r

# Command for byte-compiling the files
COMPILECMD=(progn \
	      (setq load-path (cons "." load-path)) \
	      (byte-compile-file "caml.el") \
	      (byte-compile-file "inf-caml.el") \
	      (byte-compile-file "caml-help.el") \
	      (byte-compile-file "caml-types.el") \
	      (byte-compile-file "caml-font.el") \
	      (byte-compile-file "camldebug.el"))

# This is for testing purposes
compile-only:
	$(EMACS) --batch --eval '$(COMPILECMD)'

# install the .el files, but do not compile them.
install-el:
	$(MAKE) NOCOMPILE=true install

install:
	@echo "Installing in $(INSTALL_DIR)..."
	$(INSTALL_MKDIR) $(INSTALL_DIR)
	$(INSTALL_DATA) $(FILES) $(INSTALL_DIR)
	if [ -z "$(NOCOMPILE)" ]; then \
	  cd $(INSTALL_DIR); $(EMACS) --batch --eval '$(COMPILECMD)'; \
	fi

uninstall:
	cd $(INSTALL_DIR) && $(INSTALL_RM_R) $(FILES) $(FILES:.el=.elc)

ocamltags:	ocamltags.in
	sed -e 's:@EMACS@:$(EMACS):' ocamltags.in >ocamltags
	chmod a+x ocamltags

install-ocamltags: ocamltags
	$(INSTALL_DATA) ocamltags $(INSTALL_BIN)/ocamltags

uninstall-ocamltags:
	$(INSTALL_RM_R) $(INSTALL_BIN)/ocamltags

tarball: $(TARBALL)
$(TARBALL): $(DIST_FILES)
	$(INSTALL_MKDIR) $(DIST_NAME)
	for f in $(DIST_FILES); do cp $$f $(DIST_NAME); done
	echo "(define-package \"caml\" \"$(VERSION)\" \"$(SYNOPSIS)\")" \
	     > $(DIST_NAME)/caml-pkg.el
	tar acvf $@ $(DIST_NAME)
	$(INSTALL_RM_R) $(DIST_NAME)

submit: $(TARBALL)
	@if [ ! -d packages/ ]; then \
	  echo "Make a symbolic link packages → OPAM repository/packages"; \
	  exit 1; \
	fi
	$(INSTALL_MKDIR) $(dir $(OPAM_FILE))
	sed -e "s/VERSION/$(VERSION)/" -e 's/SYNOPSIS/$(SYNOPSIS)/' \
	  caml-mode.opam > $(OPAM_FILE)
	echo "url {" >> $(OPAM_FILE)
	echo "  src: \"https://github.com/ocaml/caml-mode/releases/download/$(VERSION)/$(TARBALL)\"" >> $(OPAM_FILE)
	echo "  checksum: \"md5=`md5sum $(TARBALL) | cut -d ' ' -f 1`\"" \
	  >> $(OPAM_FILE)
	echo "}" >> $(OPAM_FILE)

clean:
	rm -f ocamltags *~ \#*# *.elc
	$(RM) -r $(TARBALL)


.PHONY: install uninstall install-el \
	ocamltags install-ocamltags uninstall-ocamltags \
        tarball submit compile-only clean

=== debian/changelog ===
caml-mode (4.9-4) unstable; urgency=medium

  * Upload to recompile against new dh-elpa (closes: #1077093)
  * Standards-version 4.7.0 (no change)

 -- Ralf Treinen <treinen@debian.org>  Fri, 26 Jul 2024 08:38:22 +0200

caml-mode (4.9-3) unstable; urgency=medium

  * Add file activate-caml-mode which a user can load to activate the mode
    on OCaml files. Add a README file to explain this.
  * Rephrase the package description.

 -- Ralf Treinen <treinen@debian.org>  Sun, 02 Jul 2023 21:47:37 +0200

caml-mode (4.9-2) unstable; urgency=medium

  [ Ralf Treinen ]
  * New upstream version
  * Refreshed patch make-pkg-file
  * Add file debian/watch
  * Standards-Version 4.6.2 (no change)
  * Debhelper compatibility level 13 (no change)
  * Set Rules-Requires-Root = no
  * Drop transitional package ocaml-mode (closes: 1038228)

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Ralf Treinen <treinen@debian.org>  Sun, 18 Jun 2023 20:04:30 +0200

=== debian/control ===
Source: caml-mode
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Ralf Treinen <treinen@debian.org>,
Build-Depends: debhelper-compat (= 13), dh-elpa
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://github.com/ocaml/caml-mode
Vcs-Git: https://salsa.debian.org/ocaml-team/caml-mode.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/caml-mode

Package: elpa-caml
Architecture: all
Depends: ${misc:Depends}, ${elpa:Depends}
Replaces: ocaml-mode (<< 4.06)
Breaks: ocaml-mode (<< 4.06)
Description: emacs mode for editing OCaml programs
 OCaml (Objective Caml) is a programming language featuring functional
 programming, mutable data structures, algebraic data types, and type
 inference.
 .
 This package provides caml-mode for editing OCaml programs with Emacs
 and XEmacs. It also works on Caml Light, the predecessor language of
 OCaml.
 .
 Caml-mode supports:
  - indentation
  - compilation and error retrieving
  - interaction with the toplevel
  - font-lock
  - imenu
 .
 Another popular emacs mode for editing OCaml files is tuareg,
 available through the elpa-tuareg package.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with elpa

override_dh_auto_build:
	$(MAKE) caml-pkg.el
	dh_auto_build

override_dh_auto_install:
	# do not execute upstream "make install"

=== debian/watch ===
version=4
https://github.com/ocaml/caml-mode/tags .*/(\d\S*)\.tar\.gz
